<template>
  <v-dialog max-width="60%" fullscreen hide-overlay
            transition="dialog-bottom-transition" v-model="dialog">
    <template v-slot:activator="{ on }">
      <FloatingButton :callback="on"/>
    </template>
    <v-card>
      <v-form @submit.prevent="save()">
        <v-toolbar dark color="primary">
          Подача жалобы
        </v-toolbar>
        <v-card-text>
          <v-layout wrap>
            <v-flex xs12>
              <v-select
                :items="types"
                :error="errors.has('type')"
                :error-messages="errors.collect('type')"
                data-vv-validate-on="change|blur"
                item-text="name"
                item-value="id"
                name="type"
                label="Тип жалобы"
                data-vv-as="Тип"
                v-validate="'required'"
                required
                v-model="editedItem.typeId"
              ></v-select>
            </v-flex>
            <v-flex xs12>
              <v-text-field
                :error="errors.has('name')"
                :error-messages="errors.collect('name')"
                data-vv-validate-on="change|blur"
                data-vv-as="Заголовок"
                name="name"
                v-model="editedItem.name"
                label="Заголовок жалобы"
                v-validate="'required'"
              ></v-text-field>
            </v-flex>
            <v-flex xs12>
              <v-textarea
                v-model="editedItem.description"
                label="Описание жалобы"
              ></v-textarea>
            </v-flex>

            <v-layout row wrap>
              <v-flex sm2>
                <label class="downloadAvatar d-flex">
                  <v-icon large class="downloadAvatarIcon mr-3">add</v-icon>
                  <span>Загрузить фото</span>
                  <input @change="addImage($event.target.files)" ref="file"
                         type="file" style="visibility: hidden; height: 0; ">
                </label>
              </v-flex>
              <v-flex sm2 class="mr-4"
                      v-for="(item, index) in editedItem.images" :key="index">
                <v-card flat tile class="d-flex scanImg">
                  <v-img
                    :src="item"
                    :lazy-src="item"
                    aspect-ratio="1"
                    class="grey lighten-2"
                  >
                    <v-icon class="deleteImg" @click="deleteImage(index)">
                      delete
                    </v-icon>
                  </v-img>
                </v-card>
              </v-flex>
            </v-layout>
          </v-layout>
        </v-card-text>
        <v-layout class="align-center justify-center">
          <v-btn flat @click="close">Закрыть</v-btn>
          <v-btn
            dark
            color="success"
            @click="save"
          >
            Подать
          </v-btn>
        </v-layout>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
  import FloatingButton from '@/components/base/FloatingButton'
  import { mapActions, mapGetters } from 'vuex'
  import { TaskModel } from '@/models/TaskModel'

  /**
   * @name CreateTask
   * @mixes Vue
   */
  export default {
    name: 'CreateTask',
    components: { FloatingButton },
    data: () => ({
      dialog: false,
      editedItem: {
        images: []
      },
      filters: TaskModel.getFilters()
    }),
    computed: {
      ...mapGetters(['types'])
    },
    methods: {
      ...mapActions([
        'getTasks',
        'saveTask'
      ]),
      addImage (file) {
        const image = file[0];
        const reader = new FileReader();
        reader.readAsDataURL(image);
        reader.onloadend = () => {
          this.editedItem.images.push(reader.result);
        };
      },
      deleteImage (index) {
        this.editedItem.images.splice(index, 1);
      },
      async save () {
        const valid = await this.$validator.validateAll();
        if (valid) {
          let createdTask = await this.saveTask(this.editedItem);
          await this.getTasks(this.filters);
          this.close();
          this.$router.push({
            'name': 'task-detail',
            params: { id: createdTask.id }
          })
        }
      },
      close () {
        this.dialog = false;
        setTimeout(() => {
          this.editedItem = {
            images: []
          }
          }, 300)
      }
    }
  }
</script>
